
package cat.bcn.noise;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;
/**
 * Clase principal del proyecto
 * @author Esteban Roman Castellanos
 * @version 1.0
*/
public class NoiseActivity extends Activity {	
	private TextView lblPosicion; 
	private TextView lblVolumen;
	private TextView lblCodigoHttp;
	private LocationManager locManager;
	private LocationListener locListener;
	private Button btonDesactivar;
	private Button btonActivar;
	private TextView lblProveedor;
	private TextView lblEnvio;
	private TextView lblConexion;
	private Json json;
	private String jsonPack;
	private Send enviar;
	private GeoLocation miGeoLocation;
	private Noise ruido1;
	private String codigoenvio;
	private Timer timer = new Timer(); //si no lo creaemos aquí no podemos usarlo en desactivar

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_noise);
        btonDesactivar = (Button)findViewById(R.id.BtonDesactivar);
        btonActivar = (Button)findViewById(R.id.BtonActivar);
        lblProveedor = (TextView)findViewById(R.id.LblProveedor);
        lblPosicion = (TextView)findViewById(R.id.LblPosicion);
		lblVolumen = (TextView)findViewById(R.id.LblRuidoVolumen);
		lblEnvio = (TextView)findViewById(R.id.LblEnvio);
		lblCodigoHttp = (TextView)findViewById(R.id.LblCodigoHttp);
		lblConexion = (TextView)findViewById(R.id.LblIsConnected);
		btonActivar.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				btonDesactivar.setVisibility(View.VISIBLE);
				btonActivar.setVisibility(View.GONE);
				String tipoConexion = isConnected();
				if(tipoConexion != null ){
		            lblConexion.setText("CONECTADO A: " + tipoConexion);
		        }
		        else{
		            lblConexion.setText("No estás conectado");
		        }
				//GEOLOCALIZACIÓN
				locManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
				miGeoLocation = new GeoLocation(locManager);
				mostrarPosicion();
				//MEDIDAS DE RUIDO
				ruido1 = new Noise();
				mostrarRuido();
				//CREAMOS EL OBJETO PARA DESPUÉS FORMATEAR EN JSON
				json = new Json();
				//COMENZASMOS EL ENVÍO DE INFORMACIÓN
				//Si se repite la pulsación no hay error ya que el timer se reinicia. 
				if(timer == null){
					Timer timer = new Timer();	
				}
				timer.scheduleAtFixedRate(new TimerTask() 
				{
					public void run() {
						TimerMetodo();
				}}, 3000, 3000 );
			}
		});
		btonDesactivar.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				Log.d("Desactivar", "Cerrando la aplicación");
				miGeoLocation.stopListener(locManager);
				timer.cancel();
	            timer = null;	
				finish();
	            System.exit(0);
			}
		});
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.noise, menu);
		return true;
	}
    /** 
    mostrarRuido
    Esté método muestra el volumen de ruido y la marca de tiempo
    @param void 
    */
    private void mostrarRuido (){
    	lblVolumen.setText("Volumen de ruido: " + String.valueOf(ruido1.getVolumen()) + " Db");
    } 
    /** 
    mostrarPosición
    Esté método manda a la interfaz del móvil la locaclización geográfica de la observación y el proveedor
    @param void 
    */
    private void mostrarPosicion() {
    		//lblLatitud.setText("Latitud: " + String.valueOf(miGeoLocation.getLatitud()));
    	lblProveedor.setText("Proveedor: " + miGeoLocation.getProveedor() + " Desfase: " + miGeoLocation.getTiempo());
    		lblPosicion.setText("Lat: " + String.format("%.3f", miGeoLocation.getLatitud()) + "  Long: " + 
    				String.format("%.3f",miGeoLocation.getLongitud()) + "  Prec: " + String.format("%.0f",miGeoLocation.getPrecision()));
    		//lblDesfase.setText(" Desfase: " + miGeoLocation.getTiempo());
    		
    		}   
    /**
     * isConnected
     * Nos devuelve el tipo de conexión que tiene activa el móvil para enviar los datos. 
     * @return isConnected
     */
    public String isConnected(){
        ConnectivityManager connMgr = (ConnectivityManager) getSystemService(Activity.CONNECTIVITY_SERVICE);
            NetworkInfo networkInfo = connMgr.getActiveNetworkInfo();
            if (networkInfo != null && networkInfo.isConnected())
                return networkInfo.getTypeName();
            else
                return null;    
    }
    /**
     * TimerMetodo se repite cada intervalo de tiempo. 
     * @return void
     */
    private void TimerMetodo (){
    	 this.runOnUiThread(Timer_Tick);
    }
    private Runnable Timer_Tick = new Runnable() {
        public void run() {
        	//no debería ser necesario destruir miGeoLocation y después crearlo otra vez
        	//pero el listner del NETWORK no funicona. No se entera de los cambios
        	miGeoLocation = null;
        	miGeoLocation = new GeoLocation(locManager);
        	mostrarPosicion();
        	mostrarRuido();
        	String tipoConexion = isConnected();
			if(tipoConexion != null ){
	            lblConexion.setText("Tipo de conexión: " + tipoConexion);
	            lblProveedor.setBackgroundColor(0xFFaaaaaa);
	            lblConexion.setBackgroundColor(0xFFaaaaaa);
	            if(miGeoLocation.getProveedor() != "off"){
	        		jsonPack = json.formato(ruido1, miGeoLocation);
	        		enviar = new Send();
	        		codigoenvio = enviar.doInBackground(jsonPack).toString().trim();
	        		if (codigoenvio.equals("200")){
	        			lblCodigoHttp.setText("Datos recibidos correctamente ");	
	        		}else{
	        			lblCodigoHttp.setText("Error. Código de error: " + codigoenvio);
	        		}
	        		lblEnvio.setText(jsonPack);
	        	}
	        }
	        else{
	            lblConexion.setText("Sin conexión");
	            lblConexion.setBackgroundColor(0xFFFF0000);
	            lblCodigoHttp.setText("No se envía información");
	            lblEnvio.setText("");
	        }
        }
    };
}
