import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import static org.junit.Assert.*;

import org.junit.Test;
public class SensorTest {
	@Test
	public void sinMetodo() throws ClientProtocolException, IOException{
	      System.out.println("Enviando una llamada sin poner el metodo ...");
	      HttpClient client = new DefaultHttpClient();
	        HttpGet request = new HttpGet("http://127.0.0.1:8080/ServiceGeoJson");
	        HttpResponse response = client.execute(request);
	        BufferedReader rd = new BufferedReader (new InputStreamReader(response.getEntity().getContent()));
	        String line = "";
	        int status = response.getStatusLine().getStatusCode();
	        System.out.println("el codigo de estado es: " + status);
	        assertTrue(status == 404);
	   }

	   @Test
	   public void sinParametros() throws ClientProtocolException, IOException{
	       System.out.println("Sin parameros ...");
	       System.out.println("Enviando una llamada sin poner el metodo ...");
		      HttpClient client = new DefaultHttpClient();
		        HttpGet request = new HttpGet("http://127.0.0.1:8080/ServiceGeoJson/Sensor");
		        HttpResponse response = client.execute(request);
		        BufferedReader rd = new BufferedReader (new InputStreamReader(response.getEntity().getContent()));
		        String line = "";
		        int status = response.getStatusLine().getStatusCode();
		        System.out.println("el codigo de estado es: " + status);
		        assertTrue(status == 400);
	   }

	   @Test
	   public void sensorDefectuoso() throws ClientProtocolException, IOException{
	       System.out.println("Sensor igual a a...");
		      HttpClient client = new DefaultHttpClient();
		        HttpGet request = new HttpGet("http://127.0.0.1:8080/ServiceGeoJson/Sensor?horas=2&sensor=a");
		        HttpResponse response = client.execute(request);
		        BufferedReader rd = new BufferedReader (new InputStreamReader(response.getEntity().getContent()));
		        String line = "";
		        int status = response.getStatusLine().getStatusCode();
		        System.out.println("el codigo de estado es: " + status);
		        assertTrue(status == 400);
	   }
	   @Test
	   public void horasDefectuosas() throws ClientProtocolException, IOException{
	       System.out.println("El parḿetro enviado en horas es un caracter alfanumerico ...");
		      HttpClient client = new DefaultHttpClient();
		        HttpGet request = new HttpGet("http://127.0.0.1:8080/ServiceGeoJson/Sensor?horas=a&sensor=2");
		        HttpResponse response = client.execute(request);
		        BufferedReader rd = new BufferedReader (new InputStreamReader(response.getEntity().getContent()));
		        String line = "";
		        int status = response.getStatusLine().getStatusCode();
		        System.out.println("el codigo de estado es: " + status);
		        assertTrue(status == 400);
	   }
	   @Test
	   public void horasNegativas() throws ClientProtocolException, IOException{
	       System.out.println("Enviamos una horas negativa ...");
		      HttpClient client = new DefaultHttpClient();
		        HttpGet request = new HttpGet("http://127.0.0.1:8080/ServiceGeoJson/Sensor?horas=-1&sensor=2");
		        HttpResponse response = client.execute(request);
		        BufferedReader rd = new BufferedReader (new InputStreamReader(response.getEntity().getContent()));
		        String line = "";
		        int status = response.getStatusLine().getStatusCode();
		        System.out.println("el codigo de estado es: " + status);
		        assertTrue(status == 400);
	   }
	   @Test
	   public void testOk() throws ClientProtocolException, IOException{
	       System.out.println("Envio de una solicitud con todo bien ...");
		      HttpClient client = new DefaultHttpClient();
		        HttpGet request = new HttpGet("http://127.0.0.1:8080/ServiceGeoJson/Sensor?horas=1&sensor=2");
		        HttpResponse response = client.execute(request);
		        BufferedReader rd = new BufferedReader (new InputStreamReader(response.getEntity().getContent()));
		        String line = "";
		        int status = response.getStatusLine().getStatusCode();
		        System.out.println("el codigo (todo bien) de estado es: " + status);
		        assertTrue(status == 503 );
	   }
}
