package cat.bcn.speed;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;

import cat.bcn.speed.GeoLocation;
import cat.bcn.speed.Json;
import cat.bcn.speed.R;
import cat.bcn.speed.Send;
public class SpeedActivity extends Activity{
	private TextView lblPosicion; 
	private TextView lblSpeed;
	private TextView lblCodigoHttp;
	private LocationManager locManager;
	private LocationListener locListener;
	private Button btonDesactivar;
	private Button btonActivar;
	private TextView lblProveedor;
	private TextView lblEnvio;
	private TextView lblConexion;
	private Json json;
	private String jsonPack;
	private String codigoenvio;
	private Send enviar;
	private GeoLocation miGeoLocation;
	private Timer timer = new Timer(); //si no lo creaemos aquí no podemos usarlo en desactivar

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_speed);
        btonDesactivar = (Button)findViewById(R.id.BtonDesactivar);
        btonActivar = (Button)findViewById(R.id.BtonActivar);
        lblProveedor = (TextView)findViewById(R.id.LblProveedor);
        lblPosicion = (TextView)findViewById(R.id.LblPosicion);
		lblSpeed = (TextView)findViewById(R.id.LblSpeed);
		lblEnvio = (TextView)findViewById(R.id.LblEnvio);
		lblCodigoHttp = (TextView)findViewById(R.id.LblCodigoHttp);
		lblConexion = (TextView)findViewById(R.id.LblIsConnected);
		btonActivar.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				String tipoConexion = isConnected();
				btonDesactivar.setVisibility(View.VISIBLE);
				btonActivar.setVisibility(View.GONE);
				if(tipoConexion != null ){
		            lblConexion.setText("CONECTADO A: " + tipoConexion);
		        }
		        else{
		            lblConexion.setText("No estás conectado");
		        }
				//GEOLOCALIZACIÓN
				locManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
				miGeoLocation = new GeoLocation(locManager);
				mostrarPosicion();
				json = new Json();
				//COMENZASMOS EL ENVÍO DE INFORMACIÓN
				//Si se repite la pulsación no hay error ya que el timer se reinicia. 
				if(timer == null){
					Timer timer = new Timer();	
				}
				timer.scheduleAtFixedRate(new TimerTask() 
				{
					public void run() {
						TimerMetodo();
				}}, 3000, 3000 );
			}
		});
		btonDesactivar.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				btonActivar.setVisibility(View.VISIBLE);
				btonDesactivar.setVisibility(View.GONE);
				miGeoLocation.stopListener(locManager);
				timer.cancel();
	            timer = null;	
				finish();
	            System.exit(0);
			}
		});
	}
    /** 
    mostrarPosición
    Esté método manda a la interfaz del móvil la locaclización geográfica de la observación y el proveedor
    @param void 
    */
    private void mostrarPosicion() {
    	lblPosicion.setText("Lat: " + String.format("%.3f", miGeoLocation.getLatitud()) + "  Long: " + 
				String.format("%.3f",miGeoLocation.getLongitud()) + "  Prec: " + String.format("%.0f",miGeoLocation.getPrecision()));
    		//lblLatitud.setText("Latitud: " + String.format("%.3f", String.valueOf(miGeoLocation.getLatitud())));
    		//lblLongitud.setText("Longitud: " + String.valueOf(miGeoLocation.getLongitud()));
    		//lblPrecision.setText("Precision: " + String.valueOf(miGeoLocation.getPrecision()) + " Desfase: " + miGeoLocation.getTiempo());
    		if(miGeoLocation.getVelocidad() == -1.0){
    			lblSpeed.setText("No hay medida de velocidad disponible");
    		}else{
    			lblSpeed.setText("velocidad: " + String.valueOf(miGeoLocation.getVelocidad()) + " Km/s");
    		}
    }   
    /**
     * isConnected
     * Nos devuelve el tipo de conexión que tiene activa el móvil para enviar los datos. 
     * @return isConnected
     */
    public String isConnected(){
        ConnectivityManager connMgr = (ConnectivityManager) getSystemService(Activity.CONNECTIVITY_SERVICE);
            NetworkInfo networkInfo = connMgr.getActiveNetworkInfo();
            if (networkInfo != null && networkInfo.isConnected())
                return networkInfo.getTypeName();
            else
                return null;    
    }
    /**
     * TimerMetodo se repite cada intervalo de tiempo. 
     * @return void
     */
    private void TimerMetodo (){
    	 this.runOnUiThread(Timer_Tick);
    }
    private Runnable Timer_Tick = new Runnable() {
        public void run() {
        	//no debería ser necesario destruir miGeoLocation y después crearlo otra vez
        	//pero el listner del NETWORK no funicona. No se entera de los cambios
        	miGeoLocation = null;
        	miGeoLocation = new GeoLocation(locManager);
        	String tipoConexion = isConnected();
        	if(tipoConexion != null && miGeoLocation.getProveedor().toString().trim().equals("gps")){
        		jsonPack = json.formato(miGeoLocation);
        		enviar = new Send();
        		codigoenvio = enviar.doInBackground(jsonPack).toString().trim();
        		if (codigoenvio.equals("200")){
        			lblCodigoHttp.setText("Datos recibidos correctamente ");	
        		}else{
        			lblCodigoHttp.setText("Error. Código de error: " + codigoenvio);
        		}
        		lblEnvio.setText(jsonPack);
        		lblProveedor.setText("GPS operativo" + " Desfase: " + miGeoLocation.getTiempo());
        		lblProveedor.setBackgroundColor(0xFFaaaaaa);
        		lblConexion.setText("Tipo de conexión: " + tipoConexion);
        		lblConexion.setBackgroundColor(0xFFaaaaaa);
        	}
        	if(tipoConexion == null){
        		lblConexion.setText("No hay ninguna conexión activa");
	            lblConexion.setBackgroundColor(0xFFFF0000);
	            lblCodigoHttp.setText("No es posible enviar información");
	            lblEnvio.setText("Conecta los datos o la wifi");
        	}else{
        		lblConexion.setBackgroundColor(0xFFaaaaaa);
        		lblConexion.setText("Tipo de conexión: " + tipoConexion);
        	}
        	if(miGeoLocation.getProveedor() == "sin datos"){
        		lblProveedor.setText("Satélites insuficientes: " + miGeoLocation.getProveedor());
        		lblEnvio.setText("Sin geolocalización no se envía nada");
        		lblProveedor.setBackgroundColor(0xFFFF0000);
        	}else{
        		lblProveedor.setBackgroundColor(0xFFaaaaaa);
        		}
        	if(miGeoLocation.getProveedor() == "nulo"){
        		lblProveedor.setText("El GPS no está activo");
    			lblProveedor.setBackgroundColor(0xFFFF0000);
    			lblEnvio.setText("Sin geolocalización no se envía nada");
        	}else{lblProveedor.setBackgroundColor(0xFFaaaaaa);}
        	mostrarPosicion();
        }
    };
}
