//Escribe sobre un fichero todas las observaciones del día anterior 
//referentes al sensor Speed. 
import redis.clients.jedis.*;
import redis.clients.util.*;
import redis.clients.jedis.exceptions.*;
import java.util.*;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import java.io.*;
public class Last24 {
	 public static void main(String[] args) {
	        Jedis jedis = new Jedis("www.peripateticos.es");
			jedis.auth("sentilo");
			jedis.dbSize();
			FileWriter file = null;
			PrintWriter pw = null;
			int i = 0;
			try{
				file = new FileWriter("/home/esteban/speed.json");
				pw = new PrintWriter(file);
				String json = "";
				String location;
				String tiempo;
				String data;
				String strLatitud = "";
				float latitud;
				String strLongitud ="";
				float longitud;
				int blanco;
				Calendar inicio = Calendar.getInstance();  
			    Calendar fin = Calendar.getInstance();
			    Calendar hoy = Calendar.getInstance();
			    long ahora = hoy.getTimeInMillis();
			    long un_dia_menos = ahora - 86400000;
			    //con zrangeByScore obtenemos las observaciones dentro de un intervalo temporal 
			    Set<String> sdid_intervalo = jedis.zrangeByScore("sid:2:observations", un_dia_menos, ahora);
			    Iterator it=sdid_intervalo.iterator();
			    JSONObject obj = new JSONObject();
			    JSONArray lisPuntos = new JSONArray();
			    while(it.hasNext())
		        {
			    	//Cuando invocamos el it.next saltamos al siguiente elemento de la lista. 
			    	//Por esto solo lo invocamos una vez. 
			    	String iteracion = (String)it.next();
			    	JSONObject puntos = new JSONObject();
			    	JSONObject punto = new JSONObject();
			    	JSONObject valores = new JSONObject();
			    	JSONArray coordenadas = new JSONArray();
			    	String value ="sdid:" + iteracion; 
			    	location = jedis.hget(value,"location");
			    	tiempo = jedis.hget(value,"ts");
			    	data = jedis.hget(value, "data");
			    	if(location != null){
			    		blanco = location.indexOf(" ");
			    		strLatitud = location.substring(0, blanco);
			    		latitud = Float.parseFloat(strLatitud);
			    		strLongitud = location.substring(blanco + 1);
			    		longitud = Float.parseFloat(strLongitud);
			    		}else{
			    			longitud = 0; latitud = 0;
			    		}
			    	coordenadas.add(longitud);
			    	coordenadas.add(latitud);
			    	punto.put("type", "Point");
			    	valores.put("prop0",data);
			    	punto.put("coordinates", coordenadas);
					puntos.put("properties", valores);
					puntos.put("type", "Feature");
					puntos.put("geometry", punto);
					lisPuntos.add(puntos);
				}
		        obj.put("type","FeatureCollection");
				obj.put("features", lisPuntos);	
				String objstring = obj.toString(); 
				pw.println(objstring);
		    }catch (IOException e) {e.printStackTrace();}
			finally {
				try{
					if (null != file) file.close();
					} catch (Exception e2) {
						e2.printStackTrace();
					}}
			}
}

